/*
 * Universal REST API
 *
 * Universal API provides a RESTful and uniform way to access blockchain resources, with a rich and reusable model across multiple protocols/cryptocurrencies.  [Documentation](https://app.blockdaemon.com/docs/ubiquity)  ### Currently supported protocols:  * algorand   * mainnet * bitcoin   * mainnet/testnet * bitcoincash   * mainnet/testnet * dogecoin   * mainnet/testnet * ethereum   * mainnet/goerli * litecoin   * mainnet/testnet * near   * mainnet/testnet * oasis   * mainnet * optimism   * mainnet * polkadot   * mainnet/westend * polygon   * mainnet * solana   * mainnet/testnet * stellar   * mainnet/testnet * tezos   * mainnet * xrp   * mainnet  ##### Pagination Certain resources contain a lot of data, more than what's practical to return for a single request. With the help of pagination, the data is split across multiple responses. Each response returns a subset of the items requested, and a continuation token.  To get the next batch of items, copy the returned continuation token to the continuation query parameter and repeat the request with the new URL. In case no continuation token is returned, there is no more data available.
 *
 * API version: 3.0.0
 * Contact: support@blockdaemon.com
 */

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package ubiquity

import (
	"encoding/json"
)

// ProtocolDetail struct for ProtocolDetail
type ProtocolDetail struct {
	// Backend API Type
	Source        *string   `json:"source,omitempty"`
	Handle        *string   `json:"handle,omitempty"`
	GenesisNumber *int64    `json:"genesis_number,omitempty"`
	Endpoints     *[]string `json:"endpoints,omitempty"`
}

// NewProtocolDetail instantiates a new ProtocolDetail object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewProtocolDetail() *ProtocolDetail {
	this := ProtocolDetail{}
	return &this
}

// NewProtocolDetailWithDefaults instantiates a new ProtocolDetail object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewProtocolDetailWithDefaults() *ProtocolDetail {
	this := ProtocolDetail{}
	return &this
}

// GetSource returns the Source field value if set, zero value otherwise.
func (o *ProtocolDetail) GetSource() string {
	if o == nil || o.Source == nil {
		var ret string
		return ret
	}
	return *o.Source
}

// GetSourceOk returns a tuple with the Source field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolDetail) GetSourceOk() (*string, bool) {
	if o == nil || o.Source == nil {
		return nil, false
	}
	return o.Source, true
}

// HasSource returns a boolean if a field has been set.
func (o *ProtocolDetail) HasSource() bool {
	if o != nil && o.Source != nil {
		return true
	}

	return false
}

// SetSource gets a reference to the given string and assigns it to the Source field.
func (o *ProtocolDetail) SetSource(v string) {
	o.Source = &v
}

// GetHandle returns the Handle field value if set, zero value otherwise.
func (o *ProtocolDetail) GetHandle() string {
	if o == nil || o.Handle == nil {
		var ret string
		return ret
	}
	return *o.Handle
}

// GetHandleOk returns a tuple with the Handle field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolDetail) GetHandleOk() (*string, bool) {
	if o == nil || o.Handle == nil {
		return nil, false
	}
	return o.Handle, true
}

// HasHandle returns a boolean if a field has been set.
func (o *ProtocolDetail) HasHandle() bool {
	if o != nil && o.Handle != nil {
		return true
	}

	return false
}

// SetHandle gets a reference to the given string and assigns it to the Handle field.
func (o *ProtocolDetail) SetHandle(v string) {
	o.Handle = &v
}

// GetGenesisNumber returns the GenesisNumber field value if set, zero value otherwise.
func (o *ProtocolDetail) GetGenesisNumber() int64 {
	if o == nil || o.GenesisNumber == nil {
		var ret int64
		return ret
	}
	return *o.GenesisNumber
}

// GetGenesisNumberOk returns a tuple with the GenesisNumber field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolDetail) GetGenesisNumberOk() (*int64, bool) {
	if o == nil || o.GenesisNumber == nil {
		return nil, false
	}
	return o.GenesisNumber, true
}

// HasGenesisNumber returns a boolean if a field has been set.
func (o *ProtocolDetail) HasGenesisNumber() bool {
	if o != nil && o.GenesisNumber != nil {
		return true
	}

	return false
}

// SetGenesisNumber gets a reference to the given int64 and assigns it to the GenesisNumber field.
func (o *ProtocolDetail) SetGenesisNumber(v int64) {
	o.GenesisNumber = &v
}

// GetEndpoints returns the Endpoints field value if set, zero value otherwise.
func (o *ProtocolDetail) GetEndpoints() []string {
	if o == nil || o.Endpoints == nil {
		var ret []string
		return ret
	}
	return *o.Endpoints
}

// GetEndpointsOk returns a tuple with the Endpoints field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ProtocolDetail) GetEndpointsOk() (*[]string, bool) {
	if o == nil || o.Endpoints == nil {
		return nil, false
	}
	return o.Endpoints, true
}

// HasEndpoints returns a boolean if a field has been set.
func (o *ProtocolDetail) HasEndpoints() bool {
	if o != nil && o.Endpoints != nil {
		return true
	}

	return false
}

// SetEndpoints gets a reference to the given []string and assigns it to the Endpoints field.
func (o *ProtocolDetail) SetEndpoints(v []string) {
	o.Endpoints = &v
}

func (o ProtocolDetail) MarshalJSON() ([]byte, error) {
	toSerialize := map[string]interface{}{}
	if o.Source != nil {
		toSerialize["source"] = o.Source
	}
	if o.Handle != nil {
		toSerialize["handle"] = o.Handle
	}
	if o.GenesisNumber != nil {
		toSerialize["genesis_number"] = o.GenesisNumber
	}
	if o.Endpoints != nil {
		toSerialize["endpoints"] = o.Endpoints
	}
	return json.Marshal(toSerialize)
}

type NullableProtocolDetail struct {
	value *ProtocolDetail
	isSet bool
}

func (v NullableProtocolDetail) Get() *ProtocolDetail {
	return v.value
}

func (v *NullableProtocolDetail) Set(val *ProtocolDetail) {
	v.value = val
	v.isSet = true
}

func (v NullableProtocolDetail) IsSet() bool {
	return v.isSet
}

func (v *NullableProtocolDetail) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableProtocolDetail(val *ProtocolDetail) *NullableProtocolDetail {
	return &NullableProtocolDetail{value: val, isSet: true}
}

func (v NullableProtocolDetail) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableProtocolDetail) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
